﻿#!/usr/bin/env python3

import sys
import os
import subprocess
import shutil

# params
program_filename = r'C:\Program Files\PDF3DReportGen\PDF3DReportGen.exe'
org_state_filename = r'multi.pdf3dsettings'

# Target
loop_num = 4

# Output PDF
template_pdfname = r"template-multi.pdf";
output_pdfname = r"multi-3D.pdf";

# Input Data
input_data = [
r"./data/00.wrl.gz",
r"./data/10.wrl.gz",
r"./data/20.wrl.gz",
r"./data/30.wrl.gz"
]

# change keyword 
def change_target(infile, old_word, new_word):

  if not os.path.isfile(infile):
    print ("Error access state file : " + infile)
    sys.exit(1)

  print('old_word = ' + old_word)
  print('new_word = ' + new_word)
  f1 = open(infile, 'r', encoding='utf-8').read()
  f2 = open(infile, 'w', encoding='utf-8')
  f2.write(f1.replace(old_word, new_word))
  
# MY_ANNOT_NO
# MY_INPUT_DATA
# MY_OUTPUT_PDF

# run
def run_batch():

  # target
  print('Starting')

  # copy template to target 3D pdf
  shutil.copy(template_pdfname, output_pdfname)

  # Loop for data
  for i in range(loop_num):

    # set file
    state_filename = org_state_filename + ".tmp"
    shutil.copy(org_state_filename, state_filename)

    # change keyword (Ouput filename)
    old_name = "MY_OUTPUT_PDF"
    out_name = output_pdfname
    change_target(state_filename, old_name, out_name)

    # change keyword (Input data)
    old_name = "MY_INPUT_DATA"
    in_name = input_data[i]
    change_target(state_filename, old_name, in_name)

    # change Annotation No
    old_name = "MY_ANNOT_NO"
    t_name = str(i+1)
    change_target(state_filename, old_name, t_name)

    # run command
    command_string = [program_filename, "-state", state_filename, "-silent"]

    # execute 
    try:
      print('running [%d] : %s ' % (i, command_string))
      success = subprocess.call(command_string)
      ##success = subprocess.Popen(command_string)
    except:
      # report error details
      print('ERROR: Unable to run : ', command_string)


  return


# Main program 
if __name__ == '__main__':

  # args (example)
  #argvs = sys.argv
  #argc = len(argvs)
  #if (argc != 2):
  #  print('Usage: %s data' % argvs[0])
  #  sys.exit(1)

  # run sample
  run_batch()


